#ifndef DX_CAP_H
#define DX_CAP_H

#include <windows.h>
#include <dshow.h>
#include <stdio.h>

#include <string>
#include <list>

namespace direct_show {

LRESULT CALLBACK WndMainProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);

HRESULT GetInterfaces(void);
HRESULT CaptureVideo();
HRESULT FindCaptureDevice(IBaseFilter ** ppSrcFilter);
//HRESULT SetupVideoWindow(void);
HRESULT ChangePreviewState(int nShow);
HRESULT HandleGraphEvent(void);

//void Msg(TCHAR *szFormat, ...);
void CloseInterfaces(void);
//void ResizeVideoWindow(void);

// Remote graph viewing functions
//HRESULT AddGraphToRot(IUnknown *pUnkGraph, DWORD *pdwRegister);
//void RemoveGraphFromRot(DWORD pdwRegister);

enum PLAYSTATE {Stopped, Paused, Running, Init};

void reportFilters();

void register_commands();

}

#endif